## postgresql-13 13.8

=== debian/changelog ===
postgresql-13 (13.8-1.pgdg90+1) stretch-pgdg; urgency=medium

  * Rebuild for stretch-pgdg.
  * Changes applied by generate-pgdg-source:
    + Moving lib packages to component 13.
    + Use clang/llvm 6.0 for jit support on amd64/i386; disable on ppc64el.
    + Using debhelper 10.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 10 Aug 2022 14:57:32 +0200

postgresql-13 (13.8-1) unstable; urgency=medium

  * New upstream version.

    + Do not let extension scripts replace objects not already belonging to
      the extension (Tom Lane) (CVE-2022-2625)

      This change prevents extension scripts from doing CREATE OR REPLACE if
      there is an existing object that does not belong to the extension.  It
      also prevents CREATE IF NOT EXISTS in the same situation.  This prevents
      a form of trojan-horse attack in which a hostile database user could
      become the owner of an extension object and then modify it to compromise
      future uses of the object by other users.  As a side benefit, it also
      reduces the risk of accidentally replacing objects one did not mean to.

      The PostgreSQL Project thanks Sven Klemm for reporting this problem.

  * Update lintian overrides.

 -- Christoph Berg <myon@debian.org>  Wed, 10 Aug 2022 14:57:32 +0200

postgresql-13 (13.7-1) unstable; urgency=medium

  * New upstream release.

    * Confine additional operations within security restricted operation
      sandboxes (Sergey Shinderuk, Noah Misch)

      Autovacuum, CLUSTER, CREATE INDEX, REINDEX, REFRESH MATERIALIZED VIEW,
      and pg_amcheck activated the security restricted operation protection
      mechanism too late, or even not at all in some code paths. A user having
      permission to create non-temporary objects within a database could
      define an object that would execute arbitrary SQL code with superuser
      permissions the next time that autovacuum processed the object, or that
      some superuser ran one of the affected commands against it.

      The PostgreSQL Project thanks Alexander Lakhin for reporting this
      problem. (CVE-2022-1552)

    * Fix default signature length for gist_ltree_ops indexes
      (Tomas Vondra, Alexander Korotkov)

      The default signature length (hash size) for GiST indexes on ltree
      columns was accidentally changed while upgrading that operator class to
      support operator class parameters. If any operations had been done on
      such an index without first upgrading the ltree extension to version
      1.2, they were done assuming that the signature length was 28 bytes
      rather than the intended 8.  This means it is very likely that such
      indexes are now corrupt.  For safety we recommend re-indexing all GiST
      indexes on ltree columns after installing this update.  (Note that GiST
      indexes on ltree[] columns, that is arrays of ltree, are not affected.)

  * Add Provides: postgresql-13-jit-llvm (= llvm version).

 -- Christoph Berg <myon@debian.org>  Tue, 10 May 2022 10:52:37 +0200

postgresql-13 (13.6-1) unstable; urgency=medium

  * New upstream release.
  * Use system default clang/llvm version.
  * Use centralized debian/rules logic in postgresql-common.

 -- Christoph Berg <myon@debian.org>  Thu, 02 Dec 2021 12:05:02 +0100

postgresql-13 (13.5-2) unstable; urgency=medium

  * Enable outline-atomics on arm64 (affects Ubuntu focal only).

 -- Christoph Berg <myon@debian.org>  Tue, 16 Nov 2021 11:56:37 +0100

postgresql-13 (13.5-1) unstable; urgency=medium

  * New upstream release.

    + Make the server and libpq reject extraneous data after an SSL or GSS
      encryption handshake (Tom Lane)

      A man-in-the-middle with the ability to inject data into the TCP
      connection could stuff some cleartext data into the start of a
      supposedly encryption-protected database session.

      This could be abused to send faked SQL commands to the server, although
      that would only work if the server did not demand any authentication
      data.  (However, a server relying on SSL certificate authentication
      might well not do so.) (CVE-2021-23214)

      This could probably be abused to inject faked responses to the client's
      first few queries, although other details of libpq's behavior make that
      harder than it sounds.  A different line of attack is to exfiltrate the
      client's password, or other sensitive data that might be sent early in
      the session.  That has been shown to be possible with a server
      vulnerable to CVE-2021-23214. (CVE-2021-23222)

      The PostgreSQL Project thanks Jacob Champion for reporting these
      problems.

 -- Christoph Berg <myon@debian.org>  Tue, 09 Nov 2021 14:54:06 +0100

postgresql-13 (13.4-4) unstable; urgency=medium

  * configure.in: Remove check for autoconf 2.69.

 -- Christoph Berg <myon@debian.org>  Thu, 30 Sep 2021 09:52:32 +0200

postgresql-13 (13.4-3) unstable; urgency=medium

  * Cherry-pick riscv spinlocks patch from upstream. (Closes: #993217)

 -- Christoph Berg <myon@debian.org>  Tue, 31 Aug 2021 11:59:29 +0200

postgresql-13 (13.4-2) unstable; urgency=medium

  * Enable spinlocks on riscv64.
  * Fix awk to be mawk, spotted by Yangfl. (Closes: #987786)
  * B-D on autoconf2.69. (Closes: #978886)
  * Spanish debconf translation by Jonathan Bustillos, thanks!
    (Closes: #986775)
  * Flatten debian/*.lintian-overrides symlinks.

 -- Christoph Berg <myon@debian.org>  Thu, 26 Aug 2021 15:34:27 +0200

=== debian/control ===
Source: postgresql-13
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Martin Pitt <mpitt@debian.org>,
 Peter Eisentraut <petere@debian.org>,
 Christoph Berg <myon@debian.org>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends:
 autoconf,
 bison,
 clang [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 debhelper (>= 10),
 dh-exec (>= 0.13~),
 docbook-xml,
 docbook-xsl (>= 1.77),
 dpkg-dev (>= 1.16.1~),
 flex,
 gdb <!nocheck>,
 gettext,
 libicu-dev,
 libio-pty-perl <!nocheck>,
 libipc-run-perl <!nocheck>,
 libkrb5-dev,
 libldap2-dev,
 libpam0g-dev | libpam-dev,
 libperl-dev,
 libreadline-dev,
 libselinux1-dev [linux-any],
 libssl-dev,
 libsystemd-dev [linux-any],
 libxml2-dev,
 libxml2-utils,
 libxslt1-dev,
 llvm-6.0-dev [amd64 i386],
 mawk,
 perl (>= 5.8),
 pkg-config,
 postgresql-common (>= 233~),
 python3-dev,
 systemtap-sdt-dev,
 tcl-dev,
 uuid-dev,
 xsltproc,
 zlib1g-dev | libz-dev
Homepage: http://www.postgresql.org/
Vcs-Browser: https://salsa.debian.org/postgresql/postgresql
Vcs-Git: https://salsa.debian.org/postgresql/postgresql.git -b 13

Package: libpq-dev
Architecture: any
Section: 13/libdevel
Depends:
 libpq5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: postgresql-doc-13
Description: header files for libpq5 (PostgreSQL library)
 Header files and static library for compiling C programs to link
 with the libpq library in order to communicate with a PostgreSQL
 database backend.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpq5
Architecture: any
Section: 13/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: PostgreSQL C client library
 libpq is a C library that enables user programs to communicate with
 the PostgreSQL database server.  The server can be on another machine
 and accessed through TCP/IP.  This version of libpq is compatible
 with servers from PostgreSQL 8.2 or later.
 .
 This package contains the run-time library, needed by packages using
 libpq.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg6
Architecture: any
Section: 13/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: run-time library for ECPG programs
 The libecpg shared library is used by programs built with ECPG
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg-dev
Architecture: any
Section: 13/libdevel
Depends:
 libecpg-compat3 (= ${binary:Version}),
 libecpg6 (= ${binary:Version}),
 libpgtypes3 (= ${binary:Version}),
 libpq-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Description: development files for ECPG (Embedded PostgreSQL for C)
 This package contains the necessary files to build ECPG (Embedded
 PostgreSQL for C) programs.  It includes the development libraries
 and the preprocessor program ecpg.
 .
 PostgreSQL is an object-relational SQL database management system.
 .
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

Package: libecpg-compat3
Architecture: any
Section: 13/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: older version of run-time library for ECPG programs
 The libecpg_compat shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpgtypes3
Architecture: any
Section: 13/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: shared library libpgtypes for PostgreSQL 13
 The libpgtypes shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-13
Architecture: any
Depends:
 locales | locales-all,
 postgresql-client-13,
 postgresql-common (>= 182~),
 ssl-cert,
 tzdata,
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 postgresql-contrib-13,
Recommends: sysstat
Description: The World's Most Advanced Open Source Relational Database
 PostgreSQL, also known as Postgres, is a free and open-source relational
 database management system (RDBMS) emphasizing extensibility and SQL
 compliance. It features transactions with Atomicity, Consistency, Isolation,
 Durability (ACID) properties, automatically updatable views, materialized
 views, triggers, foreign keys, and stored procedures. It is designed to handle
 a range of workloads, from single machines to data warehouses or Web services
 with many concurrent users.
 .
 This package provides the database server for PostgreSQL 13.
XB-Postgresql-Catversion: ${postgresql:Catversion}

Package: postgresql-client-13
Architecture: any
Multi-Arch: foreign
Depends:
 libpq5 (>= ${source:Upstream-Version}),
 postgresql-client-common (>= 182~),
 sensible-utils,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: postgresql-13, postgresql-doc-13
Provides: postgresql-client
Description: front-end programs for PostgreSQL 13
 This package contains client and administrative programs for
 PostgreSQL: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for PostgreSQL 13. If you install
 PostgreSQL 13 on a standalone machine, you need the server package
 postgresql-13, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-server-dev-13
Architecture: any
Section: libdevel
Depends:
 clang-6.0 [amd64 i386],
 libpq-dev (>= 13~~),
 llvm-6.0-dev [amd64 i386],
 postgresql-client-13,
 postgresql-common (>= 142~),
 ${misc:Depends},
 ${shlibs:Depends}
Breaks:
 postgresql-server-dev-all (<< 181~)
Description: development files for PostgreSQL 13 server-side programming
 Header files for compiling SSI code to link into PostgreSQL's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on
 modules of PostgreSQL, which would otherwise have to be built in the
 PostgreSQL source-code tree.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-doc-13
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Breaks: postgresql-common (<< 158~)
Description: documentation for the PostgreSQL database management system
 This package contains all README files, user manual, and examples for
 PostgreSQL 13. The manual is in HTML format.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plperl-13
Architecture: any
Depends:
 perl,
 postgresql-13 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides: postgresql-plperl
Description: PL/Perl procedural language for PostgreSQL 13
 PL/Perl enables an SQL developer to write procedural language functions
 for PostgreSQL 13 in Perl.  You need this package if you have any
 PostgreSQL 13 functions that use the languages plperl or plperlu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plpython3-13
Architecture: any
Depends:
 postgresql-13 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides: postgresql-plpython3
Description: PL/Python 3 procedural language for PostgreSQL 13
 PL/Python 3 enables an SQL developer to write procedural language functions
 for PostgreSQL 13 in Python 3.  You need this package if you have any
 PostgreSQL 13 functions that use the languages plpython3 or plpython3u.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-pltcl-13
Architecture: any
Depends:
 postgresql-13 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Provides: postgresql-pltcl
Description: PL/Tcl procedural language for PostgreSQL 13
 PL/Tcl enables an SQL developer to write procedural language functions
 for PostgreSQL 13 in Tcl.  You need this package if you have any
 PostgreSQL 13 functions that use the languages pltcl or pltclu.
 .
 PostgreSQL is an object-relational SQL database management system.

## postgresql-13 13.9

=== debian/changelog ===
postgresql-13 (13.9-0+deb11u1) bullseye; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Wed, 09 Nov 2022 10:00:43 +0100

postgresql-13 (13.8-0+deb11u1) bullseye; urgency=medium

  * New upstream version.

    + Do not let extension scripts replace objects not already belonging to
      the extension (Tom Lane) (CVE-2022-2625)

      This change prevents extension scripts from doing CREATE OR REPLACE if
      there is an existing object that does not belong to the extension.  It
      also prevents CREATE IF NOT EXISTS in the same situation.  This prevents
      a form of trojan-horse attack in which a hostile database user could
      become the owner of an extension object and then modify it to compromise
      future uses of the object by other users.  As a side benefit, it also
      reduces the risk of accidentally replacing objects one did not mean to.

      The PostgreSQL Project thanks Sven Klemm for reporting this problem.

 -- Christoph Berg <myon@debian.org>  Thu, 11 Aug 2022 14:00:26 +0200

postgresql-13 (13.7-0+deb11u1) bullseye-security; urgency=medium

  * New upstream release.

    * Confine additional operations within security restricted operation
      sandboxes (Sergey Shinderuk, Noah Misch)

      Autovacuum, CLUSTER, CREATE INDEX, REINDEX, REFRESH MATERIALIZED VIEW,
      and pg_amcheck activated the security restricted operation protection
      mechanism too late, or even not at all in some code paths. A user having
      permission to create non-temporary objects within a database could
      define an object that would execute arbitrary SQL code with superuser
      permissions the next time that autovacuum processed the object, or that
      some superuser ran one of the affected commands against it.

      The PostgreSQL Project thanks Alexander Lakhin for reporting this
      problem. (CVE-2022-1552)

    * Fix default signature length for gist_ltree_ops indexes
      (Tomas Vondra, Alexander Korotkov)

      The default signature length (hash size) for GiST indexes on ltree
      columns was accidentally changed while upgrading that operator class to
      support operator class parameters. If any operations had been done on
      such an index without first upgrading the ltree extension to version
      1.2, they were done assuming that the signature length was 28 bytes
      rather than the intended 8.  This means it is very likely that such
      indexes are now corrupt.  For safety we recommend re-indexing all GiST
      indexes on ltree columns after installing this update.  (Note that GiST
      indexes on ltree[] columns, that is arrays of ltree, are not affected.)

 -- Christoph Berg <myon@debian.org>  Wed, 11 May 2022 15:03:33 +0200

postgresql-13 (13.5-0+deb11u1) bullseye-security; urgency=medium

  * New upstream security release.

    + Make the server and libpq reject extraneous data after an SSL or GSS
      encryption handshake (Tom Lane)

      A man-in-the-middle with the ability to inject data into the TCP
      connection could stuff some cleartext data into the start of a
      supposedly encryption-protected database session.

      This could be abused to send faked SQL commands to the server, although
      that would only work if the server did not demand any authentication
      data.  (However, a server relying on SSL certificate authentication
      might well not do so.) (CVE-2021-23214)

      This could probably be abused to inject faked responses to the client's
      first few queries, although other details of libpq's behavior make that
      harder than it sounds.  A different line of attack is to exfiltrate the
      client's password, or other sensitive data that might be sent early in
      the session.  That has been shown to be possible with a server
      vulnerable to CVE-2021-23214. (CVE-2021-23222)

      The PostgreSQL Project thanks Jacob Champion for reporting these
      problems.

  * Flatten debian/*.lintian-overrides symlinks to fix salsa CI.

 -- Christoph Berg <myon@debian.org>  Tue, 17 Aug 2021 14:04:37 +0200

postgresql-13 (13.4-0+deb11u1) bullseye; urgency=medium

  * New upstream version.

    + Fix mis-planning of repeated application of a projection step (Tom Lane)

      The planner could create an incorrect plan in cases where two
      ProjectionPaths were stacked on top of each other.  The only known way
      to trigger that situation involves parallel sort operations, but there
      may be other instances.  The result would be crashes or incorrect query
      results. Disclosure of server memory contents is also possible.
      (CVE-2021-3677)

    + Disallow SSL renegotiation more completely (Michael Paquier)

      SSL renegotiation has been disabled for some time, but the server would
      still cooperate with a client-initiated renegotiation request. A
      maliciously crafted renegotiation request could result in a server crash
      (see OpenSSL issue CVE-2021-3449).  Disable the feature altogether on
      OpenSSL versions that permit doing so, which are 1.1.0h and newer.

 -- Christoph Berg <myon@debian.org>  Tue, 18 May 2021 13:56:18 +0200

## postgresql-13 13.10

=== debian/changelog ===
postgresql-13 (13.10-0+deb11u1) bullseye; urgency=medium

  * New upstream version.

    + libpq can leak memory contents after GSSAPI transport encryption
      initiation fails (Jacob Champion)

      A modified server, or an unauthenticated man-in-the-middle, can send a
      not-zero-terminated error message during setup of GSSAPI (Kerberos)
      transport encryption.  libpq will then copy that string, as well as
      following bytes in application memory up to the next zero byte, to its
      error report. Depending on what the calling application does with the
      error report, this could result in disclosure of application memory
      contents.  There is also a small probability of a crash due to reading
      beyond the end of memory.  Fix by properly zero-terminating the server
      message. (CVE-2022-41862)

 -- Christoph Berg <myon@debian.org>  Tue, 07 Feb 2023 15:28:39 +0100

## postgresql-13 13.11

=== debian/changelog ===
postgresql-13 (13.11-0+deb11u1) bullseye-security; urgency=medium

  * New upstream version.

    + Prevent CREATE SCHEMA from defeating changes in search_path
      (Report and fix by Alexander Lakhin, CVE-2023-2454)

      Within a CREATE SCHEMA command, objects in the prevailing search_path,
      as well as those in the newly-created schema, would be visible even
      within a called function or script that attempted to set a secure
      search_path.  This could allow any user having permission to create a
      schema to hijack the privileges of a security definer function or
      extension script.

    + Enforce row-level security policies correctly after inlining a
      set-returning function (Report by Wolfgang Walther, CVE-2023-2455)

      If a set-returning SQL-language function refers to a table having
      row-level security policies, and it can be inlined into a calling query,
      those RLS policies would not get enforced properly in some cases
      involving re-using a cached plan under a different role. This could
      allow a user to see or modify rows that should have been invisible.

 -- Christoph Berg <myon@debian.org>  Wed, 10 May 2023 20:35:39 +0200

## postgresql-13 13.13

=== debian/changelog ===
postgresql-13 (13.13-0+deb11u1) bullseye-security; urgency=medium

  * New upstream version.

    * Fix handling of unknown-type arguments in DISTINCT "any" aggregate
      functions (Tom Lane)

      This error led to a text-type value being interpreted as an unknown-type
      value (that is, a zero-terminated string) at runtime.  This could result
      in disclosure of server memory following the text value.

      The PostgreSQL Project thanks Jingzhou Fu for reporting this problem.
      (CVE-2023-5868)

    * Detect integer overflow while computing new array dimensions
      (Tom Lane)

      When assigning new elements to array subscripts that are outside the
      current array bounds, an undetected integer overflow could occur in edge
      cases.  Memory stomps that are potentially exploitable for arbitrary
      code execution are possible, and so is disclosure of server memory.

      The PostgreSQL Project thanks Pedro Gallegos for reporting this problem.
      (CVE-2023-5869)

    * Prevent the pg_signal_backend role from signalling background workers
      and autovacuum processes (Noah Misch, Jelte Fennema-Nio)

      The documentation says that pg_signal_backend
      cannot issue signals to superuser-owned processes.  It was able to
      signal these background processes, though, because they advertise a
      role OID of zero.  Treat that as indicating superuser ownership.
      The security implications of cancelling one of these process types
      are fairly small so far as the core code goes (we'll just start
      another one), but extensions might add background workers that are
      more vulnerable.

      Also ensure that the is_superuser parameter is set correctly in such
      processes.  No specific security consequences are known for that
      oversight, but it might be significant for some extensions.

      The PostgreSQL Project thanks Hemanth Sandrana and Mahendrakar
      Srinivasarao for reporting this problem. (CVE-2023-5870)

    * Fix misbehavior during recursive page split in GiST index build
      (Heikki Linnakangas)

      Fix a case where the location of a page downlink was incorrectly
      tracked, and introduce some logic to allow recovering from such
      situations rather than silently doing the wrong thing.  This error could
      result in incorrect answers from subsequent index searches. It may be
      advisable to reindex all GiST indexes after installing this update.

    * Prevent de-duplication of btree index entries for interval columns

      There are interval values that are distinguishable but compare equal,
      for example 24:00:00 and 1 day.  This breaks assumptions made by btree
      de-duplication, so interval columns need to be excluded from
      de-duplication.  This oversight can cause incorrect results from
      index-only scans.  Moreover, after updating amcheck will report an error
      for almost all such indexes.  Users should reindex any btree indexes on
      interval columns.

  * Rebase debian/patches/libpgport-pkglibdir.
  * Remove failing test 039_end_of_wal.
  * Adjust lintian overrides to work with old+new format.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Nov 2023 14:45:51 +0100

postgresql-13 (13.12-0+deb11u1) bullseye; urgency=medium

  * New upstream version.

    + Disallow substituting a schema or owner name into an extension script if
      the name contains a quote, backslash, or dollar sign (Noah Misch)

      This restriction guards against SQL-injection hazards for trusted
      extensions.

      The PostgreSQL Project thanks Micah Gate, Valerie Woolard, Tim
      Carey-Smith, and Christoph Berg for reporting this problem.
      (CVE-2023-39417)

 -- Christoph Berg <myon@debian.org>  Sun, 01 Oct 2023 21:59:50 +0200

## postgresql-13 13.15

=== debian/changelog ===
postgresql-13 (13.15-0+deb11u1) bullseye; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Tue, 07 May 2024 12:11:56 +0200

postgresql-13 (13.14-0+deb11u1) bullseye-security; urgency=medium

  * New upstream version.

    * Tighten security restrictions within REFRESH MATERIALIZED VIEW
      CONCURRENTLY (Heikki Linnakangas)

      One step of a concurrent refresh command was run under weak security
      restrictions.  If a materialized view's owner could persuade a superuser
      or other high-privileged user to perform a concurrent refresh on that
      view, the view's owner could control code executed with the privileges
      of the user running REFRESH. Fix things so that all user-determined code
      is run as the view's owner, as expected.

      The PostgreSQL Project thanks Pedro Gallegos for reporting this problem.
      (CVE-2024-0985)

 -- Christoph Berg <myon@debian.org>  Tue, 06 Feb 2024 13:54:51 +0100

## postgresql-13 13.16

=== src/bin/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin (client programs)
#
# Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/bin/Makefile
#
#-------------------------------------------------------------------------

subdir = src/bin
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = \
	initdb \
	pg_archivecleanup \
	pg_basebackup \
	pg_checksums \
	pg_config \
	pg_controldata \
	pg_ctl \
	pg_dump \
	pg_resetwal \
	pg_rewind \
	pg_test_fsync \
	pg_test_timing \
	pg_upgrade \
	pg_verifybackup \
	pg_waldump \
	pgbench \
	psql \
	scripts

ifeq ($(PORTNAME), win32)
SUBDIRS += pgevent
else
ALWAYS_SUBDIRS += pgevent
endif

$(recurse)
$(recurse_always)

=== src/common/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile
#    Makefile for src/common
#
# These files are used by the Postgres backend, and also by frontend
# programs.  These files provide common functionality that isn't directly
# concerned with portability and thus doesn't belong in src/port.
#
# This makefile generates three outputs:
#
#	libpgcommon.a - contains object files with FRONTEND defined,
#		for use by client applications
#
#	libpgcommon_shlib.a - contains object files with FRONTEND defined,
#		built suitably for use in shared libraries; for use
#		by frontend libraries
#
#	libpgcommon_srv.a - contains object files without FRONTEND defined,
#		for use only by the backend
#
# IDENTIFICATION
#    src/common/Makefile
#
#-------------------------------------------------------------------------

subdir = src/common
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

# don't include subdirectory-path-dependent -I and -L switches
STD_CPPFLAGS := $(filter-out -I$(top_srcdir)/src/include -I$(top_builddir)/src/include,$(CPPFLAGS))
STD_LDFLAGS := $(filter-out -L$(top_builddir)/src/common -L$(top_builddir)/src/port,$(LDFLAGS))
override CPPFLAGS += -DVAL_CC="\"$(CC)\""
override CPPFLAGS += -DVAL_CPPFLAGS="\"$(STD_CPPFLAGS)\""
override CPPFLAGS += -DVAL_CFLAGS="\"$(CFLAGS)\""
override CPPFLAGS += -DVAL_CFLAGS_SL="\"$(CFLAGS_SL)\""
override CPPFLAGS += -DVAL_LDFLAGS="\"$(STD_LDFLAGS)\""
override CPPFLAGS += -DVAL_LDFLAGS_EX="\"$(LDFLAGS_EX)\""
override CPPFLAGS += -DVAL_LDFLAGS_SL="\"$(LDFLAGS_SL)\""
override CPPFLAGS += -DVAL_LIBS="\"$(LIBS)\""

override CPPFLAGS := -DFRONTEND -I. -I$(top_srcdir)/src/common $(CPPFLAGS)
LIBS += $(PTHREAD_LIBS)

# If you add objects here, see also src/tools/msvc/Mkvcbuild.pm

OBJS_COMMON = \
	archive.o \
	base64.o \
	checksum_helper.o \
	config_info.o \
	controldata_utils.o \
	d2s.o \
	encnames.o \
	exec.o \
	f2s.o \
	file_perm.o \
	hashfn.o \
	ip.o \
	jsonapi.o \
	keywords.o \
	kwlookup.o \
	link-canary.o \
	md5.o \
	pg_lzcompress.o \
	pgfnames.o \
	psprintf.o \
	relpath.o \
	rmtree.o \
	saslprep.o \
	scram-common.o \
	string.o \
	stringinfo.o \
	unicode_norm.o \
	username.o \
	wait_error.o \
	wchar.o

ifeq ($(with_openssl),yes)
OBJS_COMMON += \
	protocol_openssl.o \
	sha2_openssl.o
else
OBJS_COMMON += sha2.o
endif

# A few files are currently only built for frontend, not server
# (Mkvcbuild.pm has a copy of this list, too)
OBJS_FRONTEND = \
	$(OBJS_COMMON) \
	fe_memutils.o \
	file_utils.o \
	logging.o \
	restricted_token.o

# foo.o, foo_shlib.o, and foo_srv.o are all built from foo.c
OBJS_SHLIB = $(OBJS_FRONTEND:%.o=%_shlib.o)
OBJS_SRV = $(OBJS_COMMON:%.o=%_srv.o)

# where to find gen_keywordlist.pl and subsidiary files
TOOLSDIR = $(top_srcdir)/src/tools
GEN_KEYWORDLIST = $(PERL) -I $(TOOLSDIR) $(TOOLSDIR)/gen_keywordlist.pl
GEN_KEYWORDLIST_DEPS = $(TOOLSDIR)/gen_keywordlist.pl $(TOOLSDIR)/PerfectHash.pm

all: libpgcommon.a libpgcommon_shlib.a libpgcommon_srv.a

distprep: kwlist_d.h

# libpgcommon is needed by some contrib
install: all installdirs
	$(INSTALL_STLIB) libpgcommon.a '$(DESTDIR)$(libdir)/libpgcommon.a'
	$(INSTALL_STLIB) libpgcommon_shlib.a '$(DESTDIR)$(libdir)/libpgcommon_shlib.a'

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(libdir)'

uninstall:
	rm -f '$(DESTDIR)$(libdir)/libpgcommon.a'
	rm -f '$(DESTDIR)$(libdir)/libpgcommon_shlib.a'

libpgcommon.a: $(OBJS_FRONTEND)
	rm -f $@
	$(AR) $(AROPT) $@ $^

#
# Shared library versions of object files
#

libpgcommon_shlib.a: $(OBJS_SHLIB)
	rm -f $@
	$(AR) $(AROPT) $@ $^

# Because this uses its own compilation rule, it doesn't use the
# dependency tracking logic from Makefile.global.  To make sure that
# dependency tracking works anyway for the *_shlib.o files, depend on
# their *.o siblings as well, which do have proper dependencies.  It's
# a hack that might fail someday if there is a *_shlib.o without a
# corresponding *.o, but there seems little reason for that.
%_shlib.o: %.c %.o
	$(CC) $(CFLAGS) $(CFLAGS_SL) $(CPPFLAGS) -c $< -o $@

#
# Server versions of object files
#

libpgcommon_srv.a: $(OBJS_SRV)
	rm -f $@
	$(AR) $(AROPT) $@ $^

# Because this uses its own compilation rule, it doesn't use the
# dependency tracking logic from Makefile.global.  To make sure that
# dependency tracking works anyway for the *_srv.o files, depend on
# their *.o siblings as well, which do have proper dependencies.  It's
# a hack that might fail someday if there is a *_srv.o without a
# corresponding *.o, but it works for now.
%_srv.o: %.c %.o
	$(CC) $(CFLAGS) $(subst -DFRONTEND,, $(CPPFLAGS)) -c $< -o $@

# generate SQL keyword lookup table to be included into keywords*.o.
kwlist_d.h: $(top_srcdir)/src/include/parser/kwlist.h $(GEN_KEYWORDLIST_DEPS)
	$(GEN_KEYWORDLIST) --extern $<

# Dependencies of keywords*.o need to be managed explicitly to make sure
# that you don't get broken parsing code, even in a non-enable-depend build.
keywords.o keywords_shlib.o keywords_srv.o: kwlist_d.h

# The code imported from Ryu gets a pass on declaration-after-statement,
# in order to keep it more closely aligned with its upstream.
RYU_FILES = d2s.o f2s.o
RYU_OBJS = $(RYU_FILES) $(RYU_FILES:%.o=%_shlib.o) $(RYU_FILES:%.o=%_srv.o)

$(RYU_OBJS): CFLAGS += $(PERMIT_DECLARATION_AFTER_STATEMENT)

# kwlist_d.h is in the distribution tarball, so it is not cleaned here.
clean distclean:
	rm -f libpgcommon.a libpgcommon_shlib.a libpgcommon_srv.a
	rm -f $(OBJS_FRONTEND) $(OBJS_SHLIB) $(OBJS_SRV)

maintainer-clean: distclean
	rm -f kwlist_d.h

=== src/backend/storage/Makefile ===
#
# Makefile for the storage manager subsystem
#
# src/backend/storage/Makefile
#

subdir = src/backend/storage
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

SUBDIRS     = buffer file freespace ipc large_object lmgr page smgr sync

include $(top_srcdir)/src/backend/common.mk

=== src/bin/pgevent/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/bin/pgevent
#
# Copyright (c) 1996-2020, PostgreSQL Global Development Group
#
#-------------------------------------------------------------------------

PGFILEDESC = "Eventlog message formatter"
PGAPPICON=win32

subdir = src/bin/pgevent
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

ifeq ($(PORTNAME), win32)

OBJS = \
	pgevent.o \
	pgmsgevent.o
NAME=pgevent

SHLIB_LINK =
SHLIB_EXPORTS = exports.txt

all: all-lib

install: all install-lib

include $(top_srcdir)/src/Makefile.shlib

pgmsgevent.o: pgmsgevent.rc win32ver.rc
	$(WINDRES) $< -o $@ --include-dir=$(top_builddir)/src/include --include-dir=$(top_srcdir)/src/include --include-dir=$(srcdir) --include-dir=.

clean distclean: clean-lib
	rm -f $(OBJS) win32ver.rc

endif

=== src/test/locale/Makefile ===
# src/test/locale/Makefile

subdir = src/test/locale
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global


PROGS = test-ctype
DIRS = de_DE.ISO8859-1 gr_GR.ISO8859-7 koi8-r koi8-to-win1251

all: $(PROGS)

clean distclean maintainer-clean:
	rm -f $(PROGS) *.o
	for d in $(DIRS); do \
		$(MAKE) -C $$d clean || exit; \
	done

# These behave like installcheck targets.
check-%: all
	@$(MAKE) -C `echo $@ | sed 's/^check-//'` test

=== src/test/modules/Makefile ===
# src/test/modules/Makefile

subdir = src/test/modules
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = \
		  brin \
		  commit_ts \
		  dummy_index_am \
		  dummy_seclabel \
		  snapshot_too_old \
		  test_bloomfilter \
		  test_ddl_deparse \
		  test_extensions \
		  test_ginpostinglist \
		  test_integerset \
		  test_misc \
		  test_parser \
		  test_pg_dump \
		  test_predtest \
		  test_rbtree \
		  test_rls_hooks \
		  test_shm_mq \
		  unsafe_tests \
		  worker_spi

ifeq ($(with_openssl),yes)
SUBDIRS += ssl_passphrase_callback
else
ALWAYS_SUBDIRS += ssl_passphrase_callback
endif

$(recurse)
$(recurse_always)

=== src/backend/utils/adt/Makefile ===
#
# Makefile for utils/adt
#
# src/backend/utils/adt/Makefile
#

subdir = src/backend/utils/adt
top_builddir = ../../../..
include $(top_builddir)/src/Makefile.global

override CPPFLAGS := -I. -I$(srcdir) $(CPPFLAGS)

# keep this list arranged alphabetically or it gets to be a mess
OBJS = \
	acl.o \
	amutils.o \
	array_expanded.o \
	array_selfuncs.o \
	array_typanalyze.o \
	array_userfuncs.o \
	arrayfuncs.o \
	arrayutils.o \
	ascii.o \
	bool.o \
	cash.o \
	char.o \
	cryptohashes.o \
	date.o \
	datetime.o \
	datum.o \
	dbsize.o \
	domains.o \
	encode.o \
	enum.o \
	expandeddatum.o \
	expandedrecord.o \
	float.o \
	format_type.o \
	formatting.o \
	genfile.o \
	geo_ops.o \
	geo_selfuncs.o \
	geo_spgist.o \
	inet_cidr_ntop.o \
	inet_net_pton.o \
	int.o \
	int8.o \
	json.o \
	jsonb.o \
	jsonb_gin.o \
	jsonb_op.o \
	jsonb_util.o \
	jsonfuncs.o \
	jsonpath.o \
	jsonpath_exec.o \
	jsonpath_gram.o \
	like.o \
	like_support.o \
	lockfuncs.o \
	mac.o \
	mac8.o \
	misc.o \
	name.o \
	network.o \
	network_gist.o \
	network_selfuncs.o \
	network_spgist.o \
	numeric.o \
	numutils.o \
	oid.o \
	oracle_compat.o \
	orderedsetaggs.o \
	partitionfuncs.o \
	pg_locale.o \
	pg_lsn.o \
	pg_upgrade_support.o \
	pgstatfuncs.o \
	pseudotypes.o \
	quote.o \
	rangetypes.o \
	rangetypes_gist.o \
	rangetypes_selfuncs.o \
	rangetypes_spgist.o \
	rangetypes_typanalyze.o \
	regexp.o \
	regproc.o \
	ri_triggers.o \
	rowtypes.o \
	ruleutils.o \
	selfuncs.o \
	tid.o \
	timestamp.o \
	trigfuncs.o \
	tsginidx.o \
	tsgistidx.o \
	tsquery.o \
	tsquery_cleanup.o \
	tsquery_gist.o \
	tsquery_op.o \
	tsquery_rewrite.o \
	tsquery_util.o \
	tsrank.o \
	tsvector.o \
	tsvector_op.o \
	tsvector_parser.o \
	uuid.o \
	varbit.o \
	varchar.o \
	varlena.o \
	version.o \
	windowfuncs.o \
	xid.o \
	xid8funcs.o \
	xml.o

jsonpath_scan.c: FLEXFLAGS = -CF -p -p
jsonpath_scan.c: FLEX_NO_BACKUP=yes

# jsonpath_scan is compiled as part of jsonpath_gram
jsonpath_gram.o: jsonpath_scan.c

# jsonpath_gram.c and jsonpath_scan.c are in the distribution tarball,
# so they are not cleaned here.
clean distclean maintainer-clean:
	rm -f lex.backup

like.o: like.c like_match.c

varlena.o: varlena.c levenshtein.c

include $(top_srcdir)/src/backend/common.mk

=== debian/changelog ===
postgresql-13 (13.16-1.pgdg+1) sid-pgdg; urgency=medium

  * Rebuild for sid-pgdg.
  * Changes applied by generate-pgdg-source:
    + Moving lib packages to component 13.
    + Enabling cassert.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 07 Aug 2024 16:09:15 +0200

postgresql-13 (13.16-1) unstable; urgency=medium

  * New upstream version.

    + Prevent unauthorized code execution during pg_dump (Masahiko Sawada)

      An attacker able to create and drop non-temporary objects could inject
      SQL code that would be executed by a concurrent pg_dump session with the
      privileges of the role running pg_dump (which is often a superuser).
      The attack involves replacing a sequence or similar object with a view
      or foreign table that will execute malicious code.  To prevent this,
      introduce a new server parameter restrict_nonsystem_relation_kind that
      can disable expansion of non-builtin views as well as access to foreign
      tables, and teach pg_dump to set it when available.  Note that the
      attack is prevented only if both pg_dump and the server it is dumping
      from are new enough to have this fix.

      The PostgreSQL Project thanks Noah Misch for reporting this problem.
      (CVE-2024-7348)

 -- Christoph Berg <myon@debian.org>  Wed, 07 Aug 2024 16:09:15 +0200

postgresql-13 (13.15-1) unstable; urgency=medium

  * New upstream version.

 -- Christoph Berg <myon@debian.org>  Tue, 07 May 2024 12:11:56 +0200

postgresql-13 (13.14-1) unstable; urgency=medium

  * New upstream version.

    * Tighten security restrictions within REFRESH MATERIALIZED VIEW
      CONCURRENTLY (Heikki Linnakangas)

      One step of a concurrent refresh command was run under weak security
      restrictions.  If a materialized view's owner could persuade a superuser
      or other high-privileged user to perform a concurrent refresh on that
      view, the view's owner could control code executed with the privileges
      of the user running REFRESH. Fix things so that all user-determined code
      is run as the view's owner, as expected.

      The PostgreSQL Project thanks Pedro Gallegos for reporting this problem.
      (CVE-2024-0985)

  * Restore relocatability of pg_config.

 -- Christoph Berg <myon@debian.org>  Tue, 06 Feb 2024 13:54:51 +0100

postgresql-13 (13.13-1) unstable; urgency=medium

  * New upstream version.

    * Fix handling of unknown-type arguments in DISTINCT "any" aggregate
      functions (Tom Lane)

      This error led to a text-type value being interpreted as an unknown-type
      value (that is, a zero-terminated string) at runtime.  This could result
      in disclosure of server memory following the text value.

      The PostgreSQL Project thanks Jingzhou Fu for reporting this problem.
      (CVE-2023-5868)

    * Detect integer overflow while computing new array dimensions
      (Tom Lane)

      When assigning new elements to array subscripts that are outside the
      current array bounds, an undetected integer overflow could occur in edge
      cases.  Memory stomps that are potentially exploitable for arbitrary
      code execution are possible, and so is disclosure of server memory.

      The PostgreSQL Project thanks Pedro Gallegos for reporting this problem.
      (CVE-2023-5869)

    * Prevent the pg_signal_backend role from signalling background workers
      and autovacuum processes (Noah Misch, Jelte Fennema-Nio)

      The documentation says that pg_signal_backend
      cannot issue signals to superuser-owned processes.  It was able to
      signal these background processes, though, because they advertise a
      role OID of zero.  Treat that as indicating superuser ownership.
      The security implications of cancelling one of these process types
      are fairly small so far as the core code goes (we'll just start
      another one), but extensions might add background workers that are
      more vulnerable.

      Also ensure that the is_superuser parameter is set correctly in such
      processes.  No specific security consequences are known for that
      oversight, but it might be significant for some extensions.

      The PostgreSQL Project thanks Hemanth Sandrana and Mahendrakar
      Srinivasarao for reporting this problem. (CVE-2023-5870)

    * Fix misbehavior during recursive page split in GiST index build
      (Heikki Linnakangas)

      Fix a case where the location of a page downlink was incorrectly
      tracked, and introduce some logic to allow recovering from such
      situations rather than silently doing the wrong thing.  This error could
      result in incorrect answers from subsequent index searches. It may be
      advisable to reindex all GiST indexes after installing this update.

    * Prevent de-duplication of btree index entries for interval columns

      There are interval values that are distinguishable but compare equal,
      for example 24:00:00 and 1 day.  This breaks assumptions made by btree
      de-duplication, so interval columns need to be excluded from
      de-duplication.  This oversight can cause incorrect results from
      index-only scans.  Moreover, after updating amcheck will report an error
      for almost all such indexes.  Users should reindex any btree indexes on
      interval columns.

  * Rebase debian/patches/libpgport-pkglibdir.

 -- Christoph Berg <myon@debian.org>  Tue, 07 Nov 2023 14:45:51 +0100

postgresql-13 (13.12-1) unstable; urgency=medium

  * New upstream version.

    + Disallow substituting a schema or owner name into an extension script if
      the name contains a quote, backslash, or dollar sign (Noah Misch)

      This restriction guards against SQL-injection hazards for trusted
      extensions.

      The PostgreSQL Project thanks Micah Gate, Valerie Woolard, Tim
      Carey-Smith, and Christoph Berg for reporting this problem.
      (CVE-2023-39417)

  * Test-Depend on tzdata-legacy | tzdata (<< 2023c-8).


=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  autoconf,
  bison,
  clang [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
- debhelper (>= 10),
+ debhelper-compat (= 13),
  dh-exec (>= 0.13~),
  docbook-xml,
  docbook-xsl (>= 1.77),
@@ -34,7 +34,7 @@
  libxml2-dev,
  libxml2-utils,
  libxslt1-dev,
- llvm-6.0-dev [amd64 i386],
+ llvm-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
  mawk,
  perl (>= 5.8),
  pkg-config,
@@ -42,6 +42,8 @@
  python3-dev,
  systemtap-sdt-dev,
  tcl-dev,
+ tzdata <!nocheck>,
+ tzdata-legacy <!nocheck> | tzdata (<< 2023c-8) <!nocheck>,
  uuid-dev,
  xsltproc,
  zlib1g-dev | libz-dev
@@ -149,6 +151,7 @@
  ${shlibs:Depends}
 Provides:
  postgresql-contrib-13,
+ postgresql-13-jit-llvm (= ${llvm:Version}) [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
 Recommends: sysstat
 Description: The World's Most Advanced Open Source Relational Database
  PostgreSQL, also known as Postgres, is a free and open-source relational
@@ -190,9 +193,9 @@
 Architecture: any
 Section: libdevel
 Depends:
- clang-6.0 [amd64 i386],
+ clang-${llvm:Version} [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
  libpq-dev (>= 13~~),
- llvm-6.0-dev [amd64 i386],
+ llvm-${llvm:Version}-dev [!alpha !hppa !hurd-i386 !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !riscv64 !sh4 !sparc64 !x32],
  postgresql-client-13,
  postgresql-common (>= 142~),
  ${misc:Depends},
